//go:build ignore

#include "vmlinux.h"

#include "libbpf/bpf_tracing.h"
#include "libbpf/bpf_helpers.h"
#include "libbpf/bpf_core_read.h"

char __license[] SEC("license") = "Dual MIT/GPL";

// kernel struct, not in the kernel module
struct kiocb {
        struct file* ki_filp;
};

SEC("kprobe/ctnetlink_fill_info")
void BPF_KPROBE(ctnetlink_fill_info) {
    struct kiocb* kiocb = (struct kiocb*)PT_REGS_PARM1(ctx);
    u64 file_ptr = 0;
    if (0 != bpf_core_read(&file_ptr, sizeof(file_ptr), &(kiocb->ki_filp))) {
        bpf_printk("failed to read file ptr");
        return;
    }

    bpf_printk("file ptr %x", file_ptr);
}
